﻿var FIERA = {};

var FIERA2 = {
    transform: {
        origin: { x: "left", y: "top" },
        translate: { x: 0, y: 0 },
        scale: 1,
        angle: 0,
        rx: 0,
        ry: 0,
        rz: 0
    },
    msg: {
        l: { "it": 0, "en": 1, "ru": 2 },
        m1: ["RIVENDITORI/AGENTI/DISTRIBUTORI", "RETAILERS/AGENTS/DISTRIBUTORS", "РОЗНИЧНЫЕ/АГЕНТОВ/ДИСТРИБУТОРЫ"],
        m2: ["Link esterno. Confermi ?", "External link. Confirm ?", "Внешняя ссылка. Подтвердите ?"],
        m3: ["PADIGLIONE", "HALL", "ЗАЛ"],
        m4: ["L'operazione sovrascrive i dati precedenti e può durare diversi minuti. Confermi ?", "This will overwrite the existing data and can take several minutes. Confirm ?", "Это будет перезаписывать существующие данные и может занять несколько минут. Подтвердите?"],
        m5: ["Tel: ", "Tel: ", "Тел: "],
        m6: ["COLLEZIONI", "COLLECTIONS", "КОЛЛЕКЦИИ"],
        m7: ["Fax: ", "Fax: ", "Факс: "],
        m8: ["web: ", "web: ", "Веб: "],
        m9: ["Vuoi sovrascrivere le immagini esistenti ?", "Overwrite existing pictures ?", "Заменить существующие фотографии ?"],
        m10: ["DESCRIZIONE", "DESCRIPTION", "ОПИСАНИЕ"],
        m11: ["CREDITS", "CREDITS", "БЛАГОДАРНОСТЬ"]
    },
    lingua: 1,
    servurl: "http://www.i-ws.it/fiera/",
    isapp: true
};

$(document).delegate("#pinfo", "pagebeforecreate", function init() {
    var ret;
    // imposta il supporto delle x-domain requests
    $.support.cors = true;
    $.mobile.allowCrossDomainPages = true;
    // imposta il menu di entrata
    ret = localStorage.getItem("myfair");
    if (ret !== null)
        FIERA = JSON.parse(ret);
    if (FIERA.logofiera) {
        $.mobile.changePage("#pmain");
        setmainpage(0);
    }
});
function setmainpage(dorefresh) {
    var fn = FIERA2.isapp ? FIERA.lp + FIERA.logofiera : "data/" + FIERA.codfiera + "/" + FIERA.logofiera,
        htm = "<li><div class='centrato'><img src='img/ceramics_of_italy.png' width='60%' /></div></li>" +
        "<li><div class='centrato'><img src='" + fn + "' width='60%' /></div></li>" +
        "<li><a href='javascript: setLingua(\"en\")'><div class='centrato'><font size='6'>ENGLISH</font></div></a></li>";
    if (FIERA.codfiera == "mos" || FIERA.codfiera == "mad")
        htm += "<li><a href='javascript: setLingua(\"ru\")'><div class='centrato'><font size='6'>РУССКИЙ</font></div></a></li>";
    //alert("FIERA.lp = " + FIERA.lp);    // debug
    $("#mainmenu").empty();
    $("#mainmenu").append(htm);
    if (dorefresh == 1)
        $("#mainmenu").listview("refresh");
    $(".logofiera").attr("src", "img/" + FIERA.codfiera + "_90.png");
    //$(".logofiera").attr("height", "40");
}
function download(codfiera) {
    var ret;
    if (!FIERA2.isapp || window.confirm(FIERA2.msg.m4[FIERA2.lingua])) {
        $.ajax({
            url: FIERA2.servurl + "ajaxfiera.aspx",
            type: "POST",
            dataType: "text",
            crossDomain: true,
            data: { op: 0, f: codfiera }
        }).then(function (data) {
            ret = eval(data);
            if (!ret.err) {
                if (ret.logofiera) {
                    FIERA = ret;
                    if (FIERA2.isapp) {
                        //navigator.splashscreen.show();
                        downloadFiles(codfiera).done(function () {
                            localStorage.setItem("myfair", JSON.stringify(FIERA));
                            $.mobile.changePage("#pmain");
                            setmainpage(1);
                        });
                    }
                    else {
                        localStorage.setItem("myfair", JSON.stringify(FIERA));
                        $.mobile.changePage("#pmain");
                        setmainpage(1);
                    }
                }
            }
            else {
                alert(ret.err);
            }
        }, function (jqXhr) {
            alert("connection error: " + jqXhr.status + " - " + jqXhr.readyState);
        });
    }
}
function setEspositori(toggle) {
    var k, ico, fav, htm = "";
    if (!FIERA.logofiera)
        return;
    if (toggle == 1) {
        if (!FIERA.favtog) {
            FIERA.favtog = 1;
            $(".listog").attr("src", "img/icon_favoriti.png");
        }
        else {
            FIERA.favtog = 0;
            $(".listog").attr("src", "img/icon_lista.png");
        }
    }
    for (k = 0; k < FIERA.esp.length; k++) {
        if (!FIERA.favtog || FIERA.favtog == FIERA.esp[k].fav) {
            fav = (FIERA.esp[k].fav == 1) ? " data-icon='myfavon'" : " data-icon='myfavoff'";
            ico = (FIERA.esp[k].coi == 1) ? "<img src='img/header_coi.png' class='ui-li-icon' />" : "";
            //ico = (FIERA.esp[k].coi == 1) ? "<img src='img/header_coi.png' />" : "";
            htm += "<li" + fav + "><a href='javascript:setUnEspo(" + k + ")'>" + ico + FIERA.esp[k].rg + "</a><span class='ui-li-count'>" + FIERA.esp[k].pad + " - " + FIERA.esp[k].stand + "</span></li>";
        }
    }
    $.mobile.changePage("#plistaespo");
    $("#listaesp").empty();
    $("#listaesp").append(htm);
    $("#listaesp").listview("refresh");
}
function setUnEspo(k) {
    var j, qqr, qqa, qqs, qqe, htm, testo, id, soc = "", msgc = "";
    id = FIERA2.isapp ? FIERA.lp + FIERA.esp[k].id : "data/" + FIERA.codfiera + "/" + FIERA.esp[k].id;
    testo = (FIERA2.lingua == 2) ? FIERA.esp[k].des2 : FIERA.esp[k].des1;
    qqa = FIERA.esp[k].abil || "0:0:0:0:0:0";
    qqa = qqa.split(":");
    qqe = FIERA.esp[k].ext || ".png:.png:.png:.png:.png:.png";
    qqe = qqe.split(":");
    if (qqa[2] == "1" || qqa[3] == "1" || qqa[4] == "1" || qqa[5] == "1")
        msgc = FIERA2.msg.m6[FIERA2.lingua];
    qqs = FIERA.esp[k].social.split("|");
    soc += (qqs.length > 0 && qqs[0] !== "") ? "<a href='" + qqs[0] + "' target='_blank'><img src='img/face_icon.png' width='50'/></a> " : "";
    soc += (qqs.length > 1 && qqs[1] !== "") ? "<a href='" + qqs[1] + "' target='_blank'><img src='img/twitt_icon.png' width='50'/></a> " : "";
    soc += (qqs.length > 2 && qqs[2] !== "") ? "<a href='" + qqs[2] + "' target='_blank'><img src='img/you_icon.png' width='50'/></a> " : "";
    soc += (qqs.length > 3 && qqs[3] !== "") ? "<a href='" + qqs[3] + "' target='_blank'><img src='img/pint_icon.png' width='50'/></a> " : "";
    soc += (qqs.length > 4 && qqs[4] !== "") ? "<a href='" + qqs[4] + "' target='_blank'><img src='img/insta_icon.png' width='50'/></a>" : "";
    htm = "<li data-theme='d'><table width='100%'><tr><td width='50%' valign='top'>" +
        ((qqa[0] == "1") ? "<img src='" + id + "-0" + qqe[0] + "' width='100%'/>" : "&nbsp;") +
        "</td><td width='50%' valign='top'><h1>" + FIERA.esp[k].rg + "</h1><p>" + FIERA.esp[k].ind + "<br />" + FIERA2.msg.m5[FIERA2.lingua] + FIERA.esp[k].tel + "<br />" + FIERA2.msg.m7[FIERA2.lingua] + FIERA.esp[k].fax + "<br />e-mail: " + FIERA.esp[k].ema +
        "<br />" + FIERA2.msg.m8[FIERA2.lingua] + FIERA.esp[k].web + "<br />" + soc + "</p></tr>" +
        "<tr align='left'><td><a href='javascript:togglePref(" + k + ")'>" +
        ((FIERA.esp[k].fav == "1") ? "<img src='img/icon_preferiti_accesa.png' width='50'/>" : "<img src='img/icon_preferiti.png' width='50'/>") +
        "</a></td><td>" +
        "<table cellpadding='0' cellspacing='0'><tr><td><a href='javascript:goMappa(" + k + ")'><img src='img/icon_posizione.png' width='50'/></a></td><td>" + FIERA2.msg.m3[FIERA2.lingua] + " " + FIERA.esp[k].pad + " - " + FIERA.esp[k].stand + "</td></tr></table></td></tr>" +
        "<tr><td colspan='2'>" +
        ((qqa[1] == "1") ? "<img src='" + id + "-1" + qqe[1] + "' width='100%' />" : "&nbsp;") +
        "</td></tr><tr><td colspan='2'>" + msgc + "</td></tr><tr><td colspan='2'>" +
        "<table cellpadding='0' cellspacing='0'><tr>";
    htm += (qqa[2] == "1") ? "<td><a href='javascript:goweb1(" + k + ")' data-ajax='false'><img src='" + id + "-2" + qqe[2] + "' width='100%' /></a></td>" : "<td>&nbsp;</td>";
    htm += (qqa[3] == "1") ? "<td><a href='javascript:goweb1(" + k + ")' data-ajax='false'><img src='" + id + "-3" + qqe[3] + "' width='100%' /></a></td>" : "<td>&nbsp;</td>";
    htm += (qqa[4] == "1") ? "<td><a href='javascript:goweb1(" + k + ")' data-ajax='false'><img src='" + id + "-4" + qqe[4] + "' width='100%' /></a></td>" : "<td>&nbsp;</td>";
    htm += (qqa[5] == "1") ? "<td><a href='javascript:goweb1(" + k + ")' data-ajax='false'><img src='" + id + "-5" + qqe[5] + "' width='100%' /></a></td>" : "<td>&nbsp;</td>";
    if (FIERA.esp[k].rt.length > 1)
        msgc = FIERA2.msg.m1[FIERA2.lingua];
    else
        msgc = "";
    htm += "</tr></table></td></tr><tr><td colspan='2'>&nbsp;</td></tr><tr><td colspan='2'>" + FIERA2.msg.m10[FIERA2.lingua] + "</td></tr><tr>" +
        "<td colspan='2'><p>" + testo + "</p></td></tr><tr><td>&nbsp;</td><td>&nbsp;</td></tr>" +
        "<tr><td colspan='2'>" + msgc + "</td></tr></table></li>";

    for (j = 0; j < FIERA.esp[k].rt.length; j++) {
        qqr = FIERA.esp[k].rt[j].split("|");
        if (qqr.Length > 7)
            htm += "<li><h3>" + qqr[3] + "</h3><p><strong>" + qqr[2] + "</strong></p><p>" + qqr[4] + " <b>" + qqr[5] + "</b> " + qqr[6] + " " + qqr[7] + "</p><p class='ui-li-aside'><strong>" + qqr[1] + "</strong></p></li>";
        else if (qqr.length > 6)
            htm += "<li><h3>" + qqr[2] + "</h3><p><strong>" + qqr[1] + "</strong></p><p>" + qqr[3] + " <b>" + qqr[4] + "</b> " + qqr[5] + " " + qqr[6] + "</p><p class='ui-li-aside'><strong>" + qqr[0] + "</strong></p></li>";
    }
    $.mobile.changePage("#pespo");
    $("#myespo").empty();
    $("#myespo").append(htm);
    $("#myespo").listview("refresh");
}
function zoomin() {
    FIERA2.transform.scale *= 2;
    updateElementTransform();
}
function zoomout() {
    if (FIERA2.transform.scale > 0.1) {
        FIERA2.transform.scale /= 2;
        updateElementTransform();
    }
}
function updateElementTransform() {
    var s, value = [
        'translate3d(' + FIERA2.transform.translate.x + 'px, ' + FIERA2.transform.translate.y + 'px, 0)',
        'scale(' + FIERA2.transform.scale + ', ' + FIERA2.transform.scale + ')',
        'rotate3d(' + FIERA2.transform.rx + ',' + FIERA2.transform.ry + ',' + FIERA2.transform.rz + ',' + FIERA2.transform.angle + 'deg)'
    ];
    var el = document.querySelector("#hitarea");

    s = FIERA2.transform.origin.x + " " + FIERA2.transform.origin.y;
    value = value.join(" ");
    el.style.webkitTransform = value;
    el.style.mozTransform = value;
    el.style.transform = value;
    el.style.transformOrigin = s;
    el.style.MozTransformOrigin = s;
    el.style.webkitTransformOrigin = s;
}
function goMappa(k) {
    var x, y, startx, starty;

    FIERA2.transform = {
        origin: { x: "left", y: "top" },
        translate: { x: 0, y: 0 },
        scale: 1,
        angle: 0,
        rx: 0,
        ry: 0,
        rz: 0
    };

    $.mobile.changePage("#pmappa");
    ricalcolaMappa(k);
    updateElementTransform();

    // debug
    $("#mymap").on('touchstart', function (e) {
        x = e.originalEvent.touches[0].screenX;
        y = e.originalEvent.touches[0].screenY;
        startx = FIERA2.transform.translate.x;
        starty = FIERA2.transform.translate.y;
        //alert("qq");
        //alert("x:" + x + " y:" + y);
    });
    $("#mymap").on('touchmove', function (e) {
        var adx, ady, dx, dy;
        //alert("gg"); // questo lo fa
        dx = e.originalEvent.touches[0].screenX - x;
        dy = e.originalEvent.touches[0].screenY - y;
        adx = Math.abs(dx);
        ady = Math.abs(dy);
        //alert("x:" + x + " y:" + y + " dx:" + dx + " dy:" + dy);
        if (adx > 4 || ady > 4) {
            e.preventDefault();
            FIERA2.transform.translate.x = startx + dx;
            FIERA2.transform.translate.y = starty + dy;
            //x += dx;
            //y += dy;
            updateElementTransform();
        }
    });
    // debug

    function ricalcolaMappa(k) {
        var htm, map, fn, lingua = FIERA2.msg.l[FIERA2.lingua];
        var qq, i, j, n, c, x, y, d, pad, fatt;
        if (k < 0) {
            // tutti gli stand
            i = FIERA.stand.length;
            for (j = 0; j < FIERA.pad.length; j++) {
                if (FIERA.pad[j].id == "ALL") {
                    fn = FIERA2.isapp ? FIERA.lp + FIERA.pad[j].fn : "data/" + FIERA.codfiera + "/" + FIERA.pad[j].fn;
                    break;
                }
            }
        }
        else {
            // uno stand evidenziato
            for (j = 0; j < FIERA.pad.length; j++) {
                if (FIERA.pad[j].id == FIERA.esp[k].pad) {
                    fn = FIERA2.isapp ? FIERA.lp + FIERA.pad[j].fn : "data/" + FIERA.codfiera + "/" + FIERA.pad[j].fn;
                    break;
                }
            }
            for (i = 0; i < FIERA.stand.length; i++) {
                if (FIERA.stand[i].id == FIERA.esp[k].stand && FIERA.stand[i].pad == FIERA.esp[k].pad)
                    break;
            }
        }
        if (k >= 0) {
            $("#hstandname").text(FIERA2.msg.m3[FIERA2.lingua] + " " + FIERA.esp[k].pad + " - " + FIERA.esp[k].stand);
        }
        htm = "<div id='hitarea'><table><tr><td><img src='" + fn + "' usemap='#standmap'/><map name='standmap'>";
        if (j < FIERA.pad.length) {
            d = Math.floor(($(document).width() - FIERA.pad[j].wi) / 2);
            //FIERA2.transform.translate.x = d;
            //FIERA2.transform.translate.y = d;
            FIERA2.transform.scale = ($(document).width() - 32) / FIERA.pad[j].wi;
            for (n = 0; n < FIERA.stand.length; n++) {
                // il controllo del padiglione non serve se la mappa li contiene tutti - non cancellare
                //if (FIERA.pad[j].id == "ALL" || FIERA.stand[n].pad == FIERA.pad[j].id) {
                map = FIERA.stand[n].map;
                if (n == i) {
                    // è lo stand da evidenziare
                    htm += "<area shape='poly' coords='" + map + "' href='javascript:setUnEspo(" + k + ")' alt=''/>";
                }
                else {
                    // cerca l'espositore che ha lo stand n
                    for (c = 0; c < FIERA.esp.length; c++) {
                        if (FIERA.esp[c].br == 1 && FIERA.esp[c].pad == FIERA.stand[n].pad && FIERA.esp[c].stand == FIERA.stand[n].id) {
                            htm += "<area shape='poly' coords='" + map + "' href='javascript:setUnEspo(" + c + ")' alt=''/>";
                            break;
                        }
                    }
                }
                //}
            }
            htm += "</map></td></tr></table></div>";
        }
        $("#mymap").empty();
        $("#mymap").append(htm);
    }
}
function setLingua(c) {
    FIERA2.lingua = FIERA2.msg.l[c];
    //goMappa(-1);
    setEspositori();
}
function togglePref(k) {
    FIERA.esp[k].fav = (FIERA.esp[k].fav == "1") ? "0" : "1";
    localStorage.setItem("myfair", JSON.stringify(FIERA));
    setUnEspo(k);
}
function goEventi() {
    var j, htm = "";

    for (j = 0; j < FIERA.eve.length; j++) {
        htm += "<li><h3>" + FIERA.eve[j].tit + "</h3><p><strong>" + FIERA.eve[j].loc + "</strong></p><p>" + FIERA.eve[j].tem +
            "</p><p class='ui-li-aside'><strong>" + FIERA.eve[j].dat + " - " + FIERA.eve[j].ora + "</strong></p></li>";
    }
    $.mobile.changePage("#pespo");
    $("#myespo").empty();
    $("#myespo").append(htm);
    $("#myespo").listview("refresh");
}
function downloadFiles(cod) {
    var deferred = new $.Deferred();
    var count = FIERA.file.length;
    var someExist = false;
    var overwrite = false;
    var filePool = [];
    var activeDownloads = 0;
    var maxConcurrentDownloads = 3;

    function beginCheckFile(options) {
        options.directoryEntry.getFile(options.fileName, { create: false }, onGetFileSuccess, onGetFileError);

        function onGetFileError() {
            console.log("File " + options.fileName + " does not exist.");
            options.exists = false;
            filePool.push(options);
            oneLessToCheck();
        }
        function onGetFileSuccess() {
            console.log("File " + options.fileName + " already existed.");
            options.exists = true;
            someExist = true;
            filePool.push(options);
            oneLessToCheck();
        }
    }
    function oneLessToCheck() {
        --count;

        if (count <= 0) {
            console.log("Checked all files... " + (someExist ? "Some already exist." : "All files are new."));
            if (someExist) {
                if (confirm(FIERA2.msg.m9[FIERA2.lingua])) {
                    overwrite = true;
                } else {
                    overwrite = false;
                }
            }

            nextDownloadOrEnd();
        }

        function nextDownload() {
            while (activeDownloads < maxConcurrentDownloads && filePool.length > 0) {
                var opts = filePool.shift();
                beginDownloadFile(opts);
            }

            if (filePool.length === 0 && activeDownloads === 0) {
                console.log("All files downloaded!");
                $.mobile.loading("hide");
                deferred.resolve();
            }
        }
        function nextDownloadOrEnd() {
            if (filePool.length === 0 && activeDownloads === 0) {
                console.log("All files downloaded!");
                $.mobile.loading("hide");
                deferred.resolve();
            } else {
                nextDownload();
            }
        }

        function beginDownloadFile(options) {
            if (options.exists && !overwrite) {
                console.log("Skipping " + options.fileName);
                return;
            }

            ++activeDownloads;
            console.log("Downloading " + options.fileName);
            options.fileTransfer.download(options.remoteFile, options.localFile, onTransferSuccess, onTransferError);

            function onTransferSuccess() {
                console.log("File " + options.fileName + " downloaded correctly.");
                if (/iphone|ipad|ios/i.test(device.platform)) {
                    options.directoryEntry.getFile(options.fileName, { create: false }, onGetCreatedFileSuccess, onGetCreatedFileError);
                } else {
                    --activeDownloads;
                    nextDownloadOrEnd();
                }
            }
            function onTransferError(error) {
                console.log("File " + options.fileName + " download failed: " + error.code);
                --activeDownloads;
                nextDownloadOrEnd();
            }
            function onGetCreatedFileSuccess(fileEntry) {
                console.log("Setting com.apple.MobileBackup:1 metadata for " + options.fileName);
                fileEntry.setMetadata(onSetMetadataSuccess, onSetMetadataError, { "com.apple.MobileBackup": 1 });
                --activeDownloads;
                nextDownloadOrEnd();
            }
            function onGetCreatedFileError() {
                console.log("File " + options.fileName + " was downloaded correctly but cannot be retrieved.");
                --activeDownloads;
                nextDownloadOrEnd();
            }
            function onSetMetadataSuccess() {
                console.log("Metadata successfully set.");
                // questa funzione non viene mai chiamata
            }
            function onSetMetadataError() {
                console.log("Error setting metadata.");
                // questa funzione non viene mai chiamata
            }
        }
    }

    $.mobile.loading("show");
    //alert("downloadFiles " + cod); // debug
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0,
        function onFileSystemSuccess(fileSystem) {
            fileSystem.root.getDirectory(
                "datacoi", { create: true, exclusive: false },
                function gotDirectoryEntry(directoryEntry) {
                    var k, fn, nothingToDo = true,
                        fileTransfer = new FileTransfer();
                    FIERA.lp = directoryEntry.toURL() + "/"; // FIX for older phonegap: (device.platform.toLowerCase() == "android") ? directoryEntry.toURL() + "/" : directoryEntry.fullPath + "/";
                    console.log("FIERA.lp=" + FIERA.lp); // debug

                    for (k = 0; k < FIERA.file.length; k++) {
                        fn = FIERA.file[k];
                        if (fn) {
                            nothingToDo = false;
                            beginCheckFile({
                                fileTransfer: fileTransfer,
                                directoryEntry: directoryEntry,
                                fileName: fn,
                                localFile: FIERA.lp + fn,
                                remoteFile: FIERA2.servurl + "data/" + cod + "/" + fn
                            });
                        } else {
                            oneLessToCheck();
                        }
                    }

                    if (nothingToDo) {
                        console.log("No files to download!");
                        $.mobile.loading("hide");
                        deferred.resolve();
                    }
                }, preconditionFail
            );
        }, preconditionFail);

    function preconditionFail() {
        alert("An error occourred setting up the environment.");
        deferred.reject();
    }

    return deferred.promise();
}
function goHome() {
    var ret = localStorage.getItem("myfair");
    if (ret !== null)
        FIERA = JSON.parse(ret);
    $.mobile.changePage("#pmain");
    setmainpage(1);
}
function goweb1(k) {
    var url = FIERA.esp[k].web.trim();
    if (!/^http/i.test(url))
        url = "http://" + url;
    if (!FIERA2.isapp || window.confirm(FIERA2.msg.m2[FIERA2.lingua]))
        window.open(url, "_blank");
}
